/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: Key.java,v e893bb7f7ff2 2010/05/17 21:35:21 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public final class Key<T> implements Comparable<Key<T>>
  {
    @Nonnull
    private final String name;

    protected Key (final @Nonnull String name)
      {
        this.name = name;
      }

    @Override
    public int compareTo (final @Nonnull Key<T> other)
      {
        return this.name.compareTo(other.name);
      }

    @Override
    public boolean equals (final @CheckForNull Object other)
      {
        return (other != null)
               && (other instanceof Key)
               && this.name.equals(((Key)other).name);
      }

    @Override
    public int hashCode() 
      {
        return name.hashCode();
      }
  }